HDU 1208 Pascal's Travels

来源:互联网 发布:视频播放器源码 编辑:程序博客网 时间:2024/05/17 02:42

Pascal's Travels

                                                               Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                                                                                Total Submission(s): 1921    Accepted Submission(s): 868


Problem Description
An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from the upper left corner to the lower right corner of the board. The integer in any one square dictates how large a step away from that location must be. If the step size would advance travel off the game board, then a step in that particular direction is forbidden. All steps must be either to the right or toward the bottom. Note that a 0 is a dead end which prevents any further progress. 


Consider the 4 x 4 board shown in Figure 1, where the solid circle identifies the start position and the dashed circle identifies the target. Figure 2 shows the three paths from the start to the target, with the irrelevant numbers in each removed. 


Figure 1


Figure 2
 

Input
The input contains data for one to thirty boards, followed by a final line containing only the integer -1. The data for a board starts with a line containing a single positive integer n, 4 <= n <= 34, which is the number of rows in this board. This is followed by n rows of data. Each row contains n single digits, 0-9, with no spaces between them.
 

Output
The output consists of one line for each board, containing a single integer, which is the number of paths from the upper left corner to the lower right corner. There will be fewer than 2^63 paths for any board. 
 

Sample Input
423311213123131104333212131232212051110101111111111110111101-1
 

Sample Output
307
Hint
Hint
Brute force methods examining every path will likely exceed the allotted time limit. 64-bit integer values are available as "__int64" values using the Visual C/C++ or "long long" values using GNU C/C++ or "int64" values using Free Pascal compilers.
 

Source
Mid-Central USA 2005
 

Recommend
mcqsmall   |   We have carefully selected several similar problems for you:  1180 1195 1238 1158 1104 
 

题目链接http://acm.hdu.edu.cn/showproblem.php?pid=1208

题意:

从方格的左上角走到右下角,求路径个数

只能向下、右两个方向走,每个格子上的数字代表下一步走的长度


分析:

dp + 记忆化搜索

dp[ x ][ y ] 表示从坐标 (x , y) 走到终点的路径个数

则 dp[ x ][ y ] = dp[x + step ][ y ] + dp[ x ][ y + step ] (step 为当前格子上的数字)


代码:

#include <cstdio>#include <cstring>const int dir[][2] = {0,1, 1,0};const int MAXN = 35;char cMap[MAXN][MAXN];long long dp[MAXN][MAXN];long long ans;int n;long long dfs(int x, int y){    if (dp[x][y])       //如果已经得到结果,直接返回,记忆化搜索    {        return dp[x][y];    }    if (x == n - 1 && y == n - 1)   //达到终点    {        return 1;    }    if (cMap[x][y] == '0')    {        return 0;    }    int numOfStep = cMap[x][y] - '0';   //当前位置可以跳几个格子    for (int i = 0; i < 2; i++)         //向下、右两个方向搜索    {        int tx = x + numOfStep * dir[i][0]; //下一个位置的坐标        int ty = y + numOfStep * dir[i][1];        if (tx < n && ty < n)               //判断位置合法性        {            dp[x][y] += dfs(tx, ty);        }    }    return dp[x][y];        //返回从 (x, y) 走到终点的路径数}int main(){    while (~scanf("%d", &n) && n != -1)    {        for (int i = 0; i < n; i++)        {            scanf("%s", cMap[i]);        }        memset(dp, 0, sizeof(dp));        ans = 0;        printf("%lld\n", dfs(0, 0));    }    return 0;}




0 0